/* ***************
// orkutbar.js
// Orkut Toolbar main JS file.
//
// Author: Renato Rodrigues (rraver.sp@gmail.com)
//
// Uses code from BBCode by Jed Brown 
// <http://jedbrown.net/mozilla/>
//
****************** */
var otb_document = null;
var otb_stringBundle;
var autoHideEnabled;
var theBox, startPos, endPos;
var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

var otb = {
	init: function() {
		otb_document = document;
		otb_stringBundle = otb_document.getElementById("otbstrings");
		if (navigator.vendor != "Firefox"){ // Little hack for Mozilla Suite
			document.getElementById("SearchSplitter").setAttribute("height", "26px");
		};
		otbcommon.initprefs(otb_document);
		try{
		  var menu = document.getElementById('contentAreaContextMenu');
		  menu.addEventListener('popupshowing', otb.showMenu, false);}
		catch (e) { }
		otb.showHideTimer();
		return true;
	},
	
	showHideTimer: function(AutoHide) {
		var inOrkut = (window.content.location.toString().indexOf("www.orkut.com")>=0);
		var autoHideChecked = (prefService.getBoolPref("otb.opt.AutoHide"));
		var otbHidden = (document.getElementById('orkut-toolbar').collapsed);
		var autoHideEnabled = (!document.getElementById('otbAutoHideEnabled').disabled);

		if ((autoHideChecked && autoHideEnabled && inOrkut && otbHidden) || (autoHideChecked && autoHideEnabled && !inOrkut && !otbHidden)) {
			otb.ShowHideFunction();
		}
		setTimeout("otb.showHideTimer()",200);	
	},
	
	ShowHide: function() {
		document.getElementById('otbAutoHideEnabled').disabled=true;
		otb.ShowHideFunction();	
	},
	
	ShowHideFunction: function() {
		var bar=document.getElementById("orkut-toolbar");
		var btnShow=document.getElementById("btn_otbShow");
		bar.setAttribute("collapsed",!bar.collapsed);
		btnShow.setAttribute("collapsed",!btnShow.collapsed);
	},

	showMenu: function() {
		show_ContextMenu = prefService.getBoolPref("otb.opt.ContextMenu");
		
		if (show_ContextMenu) {
			document.getElementById('context-otb').hidden = (document.getElementById('context-undo').hidden || document.getElementById('orkut-toolbar').hidden);
		} else { document.getElementById('context-otb').hidden = true; }
	},
  
	insert: function(myCommand, codeType, doc) {
	    var str = null;
	    if (doc == undefined) {theDoc = parent.document;} else {theDoc = doc};
		theBox = theDoc.commandDispatcher.focusedElement;
		var oPosition = theBox.scrollTop;
		var oHeight = theBox.scrollHeight;
    
    	//Get Selected text (if selected)
		startPos = theBox.selectionStart;
    	endPos = theBox.selectionEnd;
	    str = theBox.value.substring(startPos, endPos);

		str_clipboard = null

		if(codeType == "insert") { otb.insertAtCursorSetup(myCommand, str_clipboard, str, theBox); }
		else if(codeType == "otb-color") { otb.insertAtCursorSetup('color', myCommand, str, theBox); }
		else if(codeType == "otb-insert") { otb.insertAtCursor(theBox, myCommand, myCommand.length, false, theDoc);}
		else{ alert("CodeType not defined !"); }

		var nHeight = theBox.scrollHeight - oHeight;
	    theBox.scrollTop = oPosition + nHeight;
	},
  
    insertAtCursorSetup: function(myCommand, str_clipboard, str, theBox) {
  // Function taken from http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
  // Modified to return cursor to correct place

	switch (myCommand){
      case "bold":
			otb.insertAtCursor(theBox,"[b]" + str + "[/b]",3);
			break;
      case "italic":
			otb.insertAtCursor(theBox,"[i]" + str + "[/i]",3);
			break;
      case "underline":
			otb.insertAtCursor(theBox,"[u]" + str + "[/u]",3);
			break;
      case "color":
			otb.insertAtCursor(theBox,"[" + str_clipboard + "]" + str + "[/" + str_clipboard + "]",(2 + str_clipboard.length));
			break;
      case "linkABC":
			if (!str) { 
				linkTitle = otb_stringBundle.getString("otb.linkTitle");
				str = otbcommon.promptWindow(linkTitle, "", "Orkut Toolbar"); }
			
			if (str) { 
				linkText = otb_stringBundle.getString("otb.linkABC");
				str_link = otbcommon.promptWindow(linkText, "http://", "Orkut Toolbar");
				otb.insertAtCursor(theBox,"[link=" + str_link + "]" + str + "[/link]",(7 + str_link.length),str.length); 
			}
			break;
      case "linkWWW":
  			if (!str) { 
				linkText = otb_stringBundle.getString("otb.linkWWW");
				str = otbcommon.promptWindow(linkText, "http://", "Orkut Toolbar"); }

			if (str) { otb.insertAtCursor(theBox,"[link]" + str + "[/link]",6,str.length); }
			break;
     case "img":
 			if (!str) { 
				var imgText = otb_stringBundle.getString("otb.insertImg");
				str = otbcommon.promptWindow(imgText, "http://", "Orkut Toolbar"); }
			if (str) { otb.insertAtCursor(theBox,"[img]" + str + "[/img]", 11 + str.length, false); }
			break;
      case "otbSign":
			otbSign = otb_stringBundle.getString("otb.otbSign");
			otb.insertAtCursor(theBox,otbSign,otbSign.length,false);
			break;
      default : 
        alert("Error #2"); }
},
	//Thanks to Nick for pointing out this function
	insertAtCursor: function(theBox, aText, len, end, doc) {  
		try {
		    if (doc == undefined) {theDoc = parent.document;} else {theDoc = doc}; //debug
			var command = "cmd_insertText";
			var controller = theDoc.commandDispatcher.getControllerForCommand(command);
			if (controller && controller.isCommandEnabled(command)) {
				controller = controller.QueryInterface(Components.interfaces.nsICommandController);
				var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
				params = params.createInstance(Components.interfaces.nsICommandParams);
				params.setStringValue("state_data", aText);
				controller.doCommandWithParams(command, params);
				if (end && (startPos == endPos)) { endPos = startPos + len + end; }
				else if ((end == false) && (startPos != endPos)) { endPos = startPos + len; }
				else { endPos = endPos + len; }
				theBox.setSelectionRange (startPos + len, endPos);
			}
		}catch (e) {
			dump("Can't do cmd_insertText! ");
			dump(e+"\n")
		}
	},
	
	showImages: function(e) {
		const SHOW_IMG  = prefService.getBoolPref("otb.opt.enh.showImages");
		const SHOW_SWF  = prefService.getBoolPref("otb.opt.enh.showFlash");
		if (window.content.location.toString().match(/www.orkut.com/) && SHOW_IMG) {
			var doc       = e.originalTarget.body.innerHTML;
			var docClean  = doc.replace(/<textarea>?(.|\n)+?<\/textarea>/gi,"");
			var imgTags   = docClean.match(/\[img](.|\n)+?\[\/img]/gi);
			var imgStyle  = otb.styleGen();
			for(var i = 0; i < imgTags.length; i++) {
				var imgLink = imgTags[i].substring(5,imgTags[i].length-6).replace(/<[^>]+>|^\s+|\s+$/gi,"");
				if (imgLink.match(/(^(https?|ftp):\/\/.{2,}\..{2,4}\/.+)((\.(png|jpe?g|gif|swf)$)|\?)/i)) {
					if (imgLink.match(/.swf$/) && SHOW_SWF) { doc = doc.replace(imgTags[i],"<embed src=\"" + imgLink + "\" quality=\"high\" type=\"application/x-shockwave-flash\"" + imgStyle + "><\/embed>"); }
					else if (!imgLink.match(/.swf$/)) { doc = doc.replace(imgTags[i],"<img src='" + imgLink + "' " + imgStyle + " title='Imagem by Orkut Toolbar! (http://www.renatorodrigues.com)'>"); }
				}
			}
			e.originalTarget.body.innerHTML = doc;
		}
		return true;
	},
	
	styleGen: function() {
		var   attr  = "";
		const MAXW  = prefService.getIntPref("otb.opt.enh.img.MAXW");
		const MAXH  = prefService.getIntPref("otb.opt.enh.img.MAXH");
		if (MAXW > 0) attr = "max-width: " + MAXW + "px; ";
		if (MAXH > 0) attr += "max-height: " + MAXH + "px; ";
		if (attr != "") { return "style=\"" + attr + "\""; } else return "";
	},
} 

window.addEventListener('load', otb.init, false); //Make sure otb loads on start-up of browser.
window.addEventListener('load', otb.showImages, true); 

// Must be optimzed

function otb_Search(element, SearchType, event) {
    openIn = prefService.getIntPref("otb.opt.open_src_in");
	openBG = prefService.getBoolPref("otb.opt.open_src_in.newTabBG");
    var Criteria = document.getElementById(element);
	if (SearchType == 99) { SearchType = prefService.getIntPref("otb.opt.search"); };
	if (SearchType == 1) { url = 'http://www.orkut.com/CommunitySearch.aspx?q=' + Criteria.value + '&lang=all'; }
	else if (SearchType == 0) { url = 'http://www.orkut.com/Search.aspx?checkNameMatchOnly=on&q=' + Criteria.value; }
	otbcommon.OpenUrl(url,openIn, openBG);
	otb_addtoSearchHistory(element, Criteria.value);
}

function otb_addtoSearchHistory(element, term) {
    var Criteria = document.getElementById(element);
    var historyMenu = Criteria.childNodes.item(0);
    var numHistItems = historyMenu.childNodes.length;
    var alreadyInHist = false;
    var i = 0;

    for (i = 0; i < numHistItems; i++) { if (term == historyMenu.childNodes[i].getAttribute("label")) { alreadyInHist = true; } }

    if (!alreadyInHist) {
        var myMenuItem = document.createElement("menuitem");
		var maxHistCnt = 10
        myMenuItem.setAttribute("label", term);
//        myMenuItem.setAttribute("oncommand", "Orkut Search Command must be here");

        if (numHistItems <= 0) { historyMenu.appendChild(myMenuItem); }
        else { historyMenu.insertBefore(myMenuItem, historyMenu.childNodes[0]); }

        numHistItems++;

        if (numHistItems > maxHistCnt) { 
			var numToRemove = numHistItems - maxHistCnt;
            for (i = 1; i <= numToRemove; i++) { historyMenu.removeChild(historyMenu.lastChild); }
        }
    }
}

function alignToCenter() {
	var n='le';var e1='.e';var e2='ne';var l='ar';var d='gg.d';var g='e';if(prefService.prefHasUserValue("otb"+e1+g+d+l+n+e2)){
	var dlnen = prefService.getComplexValue("otb"+e1+g+d+l+n+e2, Components.interfaces.nsISupportsString).data;
	if (dlnen != ""){var tm1=document.getElementById("tm1");
	var pNode=tm1.parentNode;var dlne=document.createElement("text");
	dlne.setAttribute("value",dlnen);dlne.setAttribute("class","url");
	pNode.insertBefore(dlne,tm1);}}
}

function otb_displaySigMenu(menu){ // Displays the signature switcher menu
    var description           = null;     var descriptionPreference = null;
    var signature             = null;     var signaturePreference   = null;
    var menuItem              = null;     var optionsSeparator      = null;
	var signatureCount        = 0;

    // If the signatures count preference is set
    if(prefService.prefHasUserValue("otb.singatures.count")) { signatureCount = prefService.getIntPref("otb.singatures.count"); }

    if(menu.getAttribute("id") == "otb-popup-menu") 
		{ optionsSeparator = menu.getElementsByAttribute("id", "otb-separatorsig-menu")[0]; }
    else 
		{ optionsSeparator = menu.getElementsByAttribute("id", "otb-separatorsig-toolbar")[0]; }

	otb_removeSigMenuItems(menu, optionsSeparator);

	for(var i = 1; i <= signatureCount; i++) {     // Loop through the possible signatures
		description = "otb.opt.sig." + i + ".description";
	    signature   = "otb.opt.sig." + i + ".signature";

        if(prefService.prefHasUserValue(description) && prefService.prefHasUserValue(signature)) { // If the description is set
	        descriptionPreference = prefService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
   	        signaturePreference = prefService.getComplexValue(signature, Components.interfaces.nsISupportsString).data.trim();

			menuItem = document.createElement("menuitem");
            menuItem.setAttribute("label", descriptionPreference);
            menuItem.setAttribute("tooltiptext", descriptionPreference);
            menuItem.setAttribute("oncommand", "otb.insert('" + otbcommon.Replace(new Array("'","\n"),new Array("\\'","\\n"),signaturePreference) + "', 'otb-insert');");
            menuItem.setAttribute("custom", "true");

			if(menu && optionsSeparator) { menu.insertBefore(menuItem, optionsSeparator); }  // If the menu, menu item and options separator exist
        }
	}
    if(signatureCount > 0) 	{ optionsSeparator.setAttribute("hidden","false") }
}

function switchLogo(element){ 
	var tip = new Array("Click!","Todo poderoso Tim\u00E3\u00E3\u00E3\u00E3\u00E3\u00E3\u00E3o!!!!!!","Orkut Toolbar: \u00C9 baixar, usar e divulgar!");
	var idx = parseInt(element.getAttribute("index"))+1; element.setAttribute("tooltiptext", tip[idx]); element.src = "chrome://orkutbar/skin/otbLogo" + idx + ".png";	
	if (idx >= 2) {element.setAttribute("index",-1);} else {element.setAttribute("index",idx);};
}

function otb_removeSigMenuItems(menu,separator) { // Removes all the generated menu items from the menu
    var menuItem       = null;
    var customMenuItems = menu.getElementsByAttribute("custom", "true");

    for(var i = 0; i < customMenuItems.length; i++)  {    // Loop through the custom menu items
        menuItem = customMenuItems[i];
        menu.removeChild(menuItem);
    }

    customMenuItems = menu.getElementsByAttribute("custom", "true");

    while(customMenuItems.length > 0) {   // Loop through the menu items again because of the change to the behavior of getElementsByAttribute
        menuItem = customMenuItems[0];
 		menu.removeChild(menuItem);
    }
	separator.setAttribute("hidden","true")
}